// функция - получить элемент по координатам
function element(coord) {
    return $(`#board .row.${coord[1]} .cell.${coord[0]}`);
}
// функция - получить значение элемента
function getValue(element) {
    return parseInt(element.attr('data-val'));
}
// функция - получить координаты элемента
function getCoords(element) {
    return element.attr('data-coords').split(',')
        .map((coord) => parseInt(coord));
}
// функция задержки выполнения
function sleep(ms) {
    return new Promise(resolve => setTimeout(resolve, ms));
}
// фукнция переключения игры
function togglePlay() {
    if($('#play').hasClass('play')) {
        // включаем игру!
        playing = true;
        $('#play')
            .removeClass('play')
            .addClass('stop')
            .html('CTOП');
        play();
    } else {
        // выключаем игру!
        playing = false;
        $('#play')
            .removeClass('stop')
            .addClass('play')
            .html('Старт');
    }
}
// функция - сделать правило
function makeRule(ruleId) {
    let decide; let transform; let action;
	//Например такое правило:
    //если число в ячейке меньше 2, тогда не менять значение и идти вперед
    switch($('#decider').val()) {
        case 'less':
            decide = decider.ifValLessThan($('#deciderNum').val());
            break;
        case 'equal':
            decide = decider.ifValIs($('#deciderNum').val());
            break;
        case 'greater':
            decide = decider.ifValGreaterThan($('#deciderNum').val());
            break;
    }

    let transformNum = $('#transformerNum').val();
    switch($('#transformation').val()) {
        case 'nothing':
            transform = transformer.doNothing();
            break;
        case 'increment':
            transform = transformer.add(transformNum);
            break;
        case 'decrement':
            transform = transformer.subtract(transformNum);
            break;
        case 'set':
            transform = transformer.make(transformNum);
            break;
    }

    switch($('#action').val()) {
        case 'forward':
            action = mover.goForward();
            break;
        case 'right':
            action = mover.goRight();
            break;
        case 'left':
            action = mover.goLeft();
            break;
        case 'backward':
            action = mover.goBack();
            break;
    }

    return new MoveRule(ruleId, board, decide, transform, action);
}

const modalText = {
    makeRules: "<h1>Надо определить правила! </h1><br> \
	Добавьте новое правило, указывающее Колобку, куда идти \
    с помощью панели управления.",

    stuck: "<h1>Ваш Колобок застрял! </h1> \
	<i>Он делает одно и то же снова и снова!</i><br> \
    Колобок застрял в одном состоянии по вашим правилам, \
    и не может двигаться, независимо от того, сколько раз вы нажимаете эту кнопку!<br> \
    Надо как-то поменять правила! Колобок поменяет поведение после ввода новых правил."
}
// функция - сделать модальное окно
function makeModal(text) {
    const modal = new tingle.modal({
        footer: false,
        closeMethods: ['overlay', 'button', 'escape'],
        closeLabel: "Close",
        cssClass: ['custom-class-1', 'custom-class-2'],
    });
    modal.setContent(text);
    modal.open();
}
